/**********************************
*
*	MemLeakTest.h
*
*
*	Tests for memory leaks by printing out number of objects not yet destroyed
*
***********************************/

#ifndef MemLeakTesth

#define MemLeakTesth = 1


#include "AdamLibraryDebug.h"
#include "aList.h"
#include "Allele.h"
#include "ANOVAGenetics.h"
#include "ANOVALine.h"
#include "ANOVATable.h"
#include "BootList.h"
#include "dataColumnRec.h"
#include "dataColumnRecNum.h"
#include "dataColumnRecStr.h"
#include "dataSetRec.h"
#include "GeneFrequencyDistribution.h"
#include "GeneticGridCell.h"
#include "GeneticLandScape.h"
#include "GeneralLinearModel.h"
#include "CoreGenome.h"
#include "Genome.h"
#include "GenotypeFreqDistribution.h"
#include <fstream.h>
#include <iostream.h>
#include "LandScape.h"
#include "aMatrix.h"
#include "MatrixList.h"
#include "PartitionedMatrix.h"
#include "Phenotype.h"
#include "RandomList.h"
#include "Randomness.h"
//#include "ReadAndManageGelJock.h"
#include "RegulatedAllele.h"
#include "RegulatedGenome.h"
#include "SexualGeneticLandScape.h"
#include "SexualGeneticPopulation.h"
#include "SexualGeneticIndividual.h"
#include "StatList.h"
#include "StringClass.h"
#include "StringList.h"
#include "aVector.h"

void PrintMemUsageSummary(ostream& outFile = cout);







#endif
