/***********************************
*
*	CodominantMarkerMCMCData.h
*
*	This class links the Metropolis-Hastings MCMC classes with the
*	data structure for codominant markers.
************************************/

#ifndef CodominantMarkerMCMCDatah
#define CodominantMarkerMCMCDatah = 1

//#include "Element.cpp"
//#include "aList.cpp"
#include "MetropolisHastings.h"
#include "CodominantMarkerData.h"
#include "MemoryManager.h"

// class MetropolisHastingsData defined in MetropolisHastings.h

class CodominantMarkerMCMCData: virtual public MetropolisHastingsData,
								virtual public CodominantMarkerData{
  public:
	
	CodominantMarkerMCMCData(void){
//				SetPointerToDerivedSelf();
				}
	CodominantMarkerMCMCData(CodominantMarkerMCMCData& d){
				CodominantMarkerData::Initialize(d);
//				SetPointerToDerivedSelf();
				}
	CodominantMarkerMCMCData(CodominantMarkerData& cmd){
				CodominantMarkerData::Initialize(cmd);
//				SetPointerToDerivedSelf();
				}
		
	~CodominantMarkerMCMCData(void){
//				pointerToDerivedSelf_ = 0;
				}
	
//	virtual EvolutionaryGeneticsData* Duplicate(void){
//			return NEW CodominantMarkerMCMCData(*this);}

	virtual CodominantMarkerMCMCData* _Duplicate(void){
			return NEW CodominantMarkerMCMCData(*this);}

//	virtual void SetPointerToDerivedSelf(void){//always override in derived
//					pointerToDerivedSelf_ = (long)this;}
	virtual long GetPointerToDerivedSelf(void){//always override in derived
					return (long)this;}
						

	
/*	long double q(int pop, int loc, int marker);//local frequency
	
	long double Q(int loc, int marker);//global frequency

	int GloballyPolymorphic(int loc);
	
	int n(int pop, int loc);
	
	long nalleles(int loc);
		
	long nloci(void);
		
	long npop(void);
*/		
		
	};//end class CodominantMarkerMCMCData



#endif
