/***********************************
*
*	DominantMarkerMCMCData.h
*
*	This class links the Metropolis-Hastings MCMC classes with the
*	data structure for dominant markers.
************************************/

#ifndef DominantMarkerMCMCDatah
#define DominantMarkerMCMCDatah = 1

//#include "Element.cpp"
//#include "aList.cpp"
#include "MetropolisHastings.h"
#include "DominantMarkerData2.h"
#include "MemoryManager.h"

// class MetropolisHastingsData defined in MetropolisHastings.h

class DominantMarkerMCMCData: virtual public MetropolisHastingsData,
								virtual public DominantMarkerData2{
  public:
	
	DominantMarkerMCMCData(void){
//				SetPointerToDerivedSelf();
				}
	DominantMarkerMCMCData(DominantMarkerMCMCData& d){
				DominantMarkerData2::Initialize(d);
//				SetPointerToDerivedSelf();
				}
	DominantMarkerMCMCData(DominantMarkerData2& cmd){
				DominantMarkerData2::Initialize(cmd);
//				SetPointerToDerivedSelf();
				}
		
	~DominantMarkerMCMCData(void){
//				pointerToDerivedSelf_ = 0;
				}
	
//	virtual EvolutionaryGeneticsData* Duplicate(void){
//			return NEW CodominantMarkerMCMCData(*this);}

	virtual DominantMarkerMCMCData* _Duplicate(void){
			return NEW DominantMarkerMCMCData(*this);}

//	virtual void SetPointerToDerivedSelf(void){//always override in derived
//					pointerToDerivedSelf_ = (long)this;}
	virtual long GetPointerToDerivedSelf(void){//always override in derived
					return (long)this;}
						

	
/*	long double q(int pop, int loc, int marker);//local frequency
	
	long double Q(int loc, int marker);//global frequency

	int GloballyPolymorphic(int loc);
	
	int n(int pop, int loc);
	
	long nalleles(int loc);
		
	long nloci(void);
		
	long npop(void);
*/		
		
	};//end class DominantMarkerMCMCData



#endif
