/***********************************
*
*	SexLinkedCodominantMarkerMCMCData.h
*
*	This class links the Metropolis-Hastings MCMC classes with the
*	data structure for codominant markers.
************************************/

#ifndef SexLinkedCodominantMarkerMCMCDatah
#define SexLinkedCodominantMarkerMCMCDatah = 1

//#include "Element.cpp"
//#include "aList.cpp"
#include "MetropolisHastings.h"
#include "SexLinkedCodomMarkerData.h"
#include "MemoryManager.h"

// class MetropolisHastingsData defined in MetropolisHastings.h

class SexLinkedCodominantMarkerMCMCData: virtual public MetropolisHastingsData,
								virtual public SexLinkedCodomMarkerData{
  public:
	
	SexLinkedCodominantMarkerMCMCData(void){
//				SetPointerToDerivedSelf();
				}
	SexLinkedCodominantMarkerMCMCData(SexLinkedCodominantMarkerMCMCData& d){
				SexLinkedCodomMarkerData::Initialize(d);
//				SetPointerToDerivedSelf();
				}
	SexLinkedCodominantMarkerMCMCData(SexLinkedCodomMarkerData& cmd){
				SexLinkedCodomMarkerData::Initialize(cmd);
//				SetPointerToDerivedSelf();
				}
		
	~SexLinkedCodominantMarkerMCMCData(void){
//				pointerToDerivedSelf_ = 0;
				}
	
//	virtual EvolutionaryGeneticsData* Duplicate(void){
//			return NEW CodominantMarkerMCMCData(*this);}

	virtual SexLinkedCodominantMarkerMCMCData* _Duplicate(void){
			return NEW SexLinkedCodominantMarkerMCMCData(*this);}

//	virtual void SetPointerToDerivedSelf(void){//always override in derived
//					pointerToDerivedSelf_ = (long)this;}
	virtual long GetPointerToDerivedSelf(void){//always override in derived
					return (long)this;}
						

	
/*	long double q(int pop, int loc, int marker);//local frequency
	
	long double Q(int loc, int marker);//global frequency

	int GloballyPolymorphic(int loc);
	
	int n(int pop, int loc);
	
	long nalleles(int loc);
		
	long nloci(void);
		
	long npop(void);
*/		
		
	};//end class SexLinkedCodominantMarkerMCMCData



#endif
