/***************************************
*
*
*	InlineTemplates.h
*
*
****************************************/
#ifndef InlineTemplatesh
#define InlineTemplatesh = 1



#include <math.h>
template <class T> inline int sign(T x) 
	{return x<0 ? (-1):1;}

template <class T> inline T ABS(T x) 
	{return x<(T)0 ? (-x):x;}//ABSOUTE VALUE TEMPLATE FUNCTION

template <class T> inline long DIV(T i, T j)
	{return long(i/j);}
	
template <class T> inline long MOD(T i, T j)
	{return long( i - j * long(i/j));}

template <class T> inline int even(T x)
	{T two = (T)2.0; return MOD(x, two) ? 0:1;}

template <class T> inline int odd(T x)
	{T y = T(x-1.0); return (even(y));}

template <class T> inline T MIN(T x, T y) 
	{return x<y ? x:y;}

template <class T> inline T MAX(T x, T y) 
	{return y<x ? x:y;}

template <class T> inline T ROUND(T n, const int decimalPlace){//n is the number: base 10
		long double val, nn = (long double)n, p=(long double)1.0;
		int i;
		if(decimalPlace>=0){
				for(i=0;i<decimalPlace;++i){
					p *= (long double)10.0;}}
			else{
				for(i=0;i<-decimalPlace;++i){
					p /= (long double)10.0;}}
		nn *= p;
//		nn /= p;
//		T retval = round(nn);
//		retval *= p;
//		return retval;
		val = round(nn)/p;
		return (T)val;
		//return (T)(round(nn)*p);
		}//ROUND(T, const int)
		
template <class T> inline long double sqr(T x) 
	{return x * x;}

template <class T> inline long double sqrt(T x) 
	{return exp(ln(x)/(long double)2.0);}

template <class T, class U> inline long double root(T x, U y) 
	{return exp(ln((long double)x)/(long double)y);}

template <class T> inline long double cuberoot(T x) 
	{return exp(ln((long double)x)/(long double)3.0);}

template <class T> inline long double ln(T x) 
	{return log(x);}

template <class T> inline void SWAP(T& x, T& y) 
	{T temp = x; x = y; y = temp;}

inline int CharToInteger(char c)
	{return (int)( c-'0');}


inline const long double PI(void){
	const long double pival = 3.1415926535897932384626433832795028841;
	return pival;}

inline const long double E(void){
	const long double eval = 2.71828182845904523536028747135266249;
	return eval;}
	
inline const long double GoldenRatio(void){
	const long double eval = 1.6180339887498948482045868343656;
	return eval;
	}

const long double zero = (long double)0.0;
const long double half = (long double)0.5;
const long double one = (long double)1.0;
const long double two = (long double)2.0;
const long double three = (long double)3.0;
const long double four = (long double)4.0;
const long double five = (long double)5.0;
const long double six = (long double)6.0;
const long double seven = (long double)7.0;
const long double eight = (long double)8.0;
const long double nine = (long double)9.0;
const long double ten = (long double)10.0;







#endif

