/*******************************************
*
*
*	PartitionedMatrix.h
*
*	A class that implements a matrix of matrices of long doubles
*
*
*
************************************************/

#ifndef PartitionedMatrixh
#define PartitionedMatrixh = 1

#include "Element.h"
#include "aList.h"
#include "aVector.h"
#include "aMatrix.h"
#include "MatrixList.h"
#include <iostream.h>
#include "StringClass.h"
#include "MemoryManager.h"
#include "InlineTemplates.h"

class PartitionedMatrix: public ObjList<MatrixList>{
	public://each MatrixList is a row
	PartitionedMatrix(void):ObjList<MatrixList>(){
		}
	PartitionedMatrix(PartitionedMatrix& m):ObjList<MatrixList>(m){
		}
	PartitionedMatrix(PartitionedMatrix* m):ObjList<MatrixList>(m){
		}
	~PartitionedMatrix(void){
		Clear();
		}
	
	void BadOperation(aString& e){
		cout<<"ERROR:  "<<e<<endl;}
	aMatrix<long double>* 	Flatten (void);//returns a combination of the matrices
	aMatrix<long double>* 	sForm(aMatrix<long double>& m, int index, int size);
				//returns a flattened square matrix A with elements a11=ai1=a1i=aii=m, others zero
	};//end class PartitionedMatrix




#endif
