/***********************************
*
*
*	StringList.h
*
*	Implements a variable-length list of aString objects
*
******************************************/


#ifndef StringListh
#define StringListh = 1

#include "StringClass.h"
#include "Element.h"
#include "aList.h"
#include "InlineTemplates.h"
#include "MemoryManager.h"



class StringList : public ObjList<aString> {
	public:
		StringList(void){
			}
		StringList(StringList& toCopy);
		StringList(StringList* toCopy);
		virtual ~StringList(void){
			}
virtual ObjList<aString>* Duplicate(void);//returns list as a base-class object

		void Print(ostream& outFile);//file assumed open
			//primitive debugging output, one string per line
		void Sort(void) {
			if(len()<2){return;}
			Sort(0,len()-1);}
		void Sort(long start, long finish);
		StringList&	operator= (StringList& z){			
			ObjList<aString>::operator=(z);
			return *this;
			}
friend int operator== (StringList& a, StringList& b){
		ObjList<aString>& aa = a;
		ObjList<aString>& bb = b;
  		return (aa == bb);}
friend int operator!= (StringList& a, StringList& b){
  		return !(a==b);}
  		
  		

	};


#endif
