/**********************************
*
*	MemLeakTest.cp
*
*
*	Tests for memory leaks by printing out number of objects not yet destroyed
*
***********************************/

#ifndef MemLeakTestcp

#define MemLeakTestcp = 1


#include "MemLeakTest.h"
#ifdef MemoryLeakDebug

void PrintMemUsageSummary(ostream& outFile){
	if (aList<int>::memIDList_.len()>0){outFile<<"aList<int> : ";  aList<int>::PrintIDListLen(outFile);}
	if (aList<float>::memIDList_.len()>0){outFile<<"aList<float> : ";  aList<float>::PrintIDListLen(outFile);}
	if (aList<double>::memIDList_.len()>0){outFile<<"aList<double> : ";  aList<double>::PrintIDListLen(outFile);}
	if (aList<long>::memIDList_.len()>0){outFile<<"aList<long> : ";  aList<long>::PrintIDListLen(outFile);}
	if (ANOVAGenetics::memIDList_.len()>0){outFile<<"ANOVAGenetics : ";  ANOVAGenetics::PrintIDListLen(outFile);}
	if (ANOVALine::memIDList_.len()>0){outFile<<"ANOVALine : ";  ANOVALine::PrintIDListLen(outFile);}
	if (ANOVATable::memIDList_.len()>0){outFile<<"ANOVATable : ";  ANOVATable::PrintIDListLen(outFile);}
//	if (BootList<int>::memIDList_.len()>0){outFile<<"BootList<int> : ";  BootList<int>::PrintIDListLen(outFile);}
	if (BootList<double>::memIDList_.len()>0){outFile<<"BootList<double> : ";  BootList<double>::PrintIDListLen(outFile);}
//	if (BootList<long>::memIDList_.len()>0){outFile<<"BootList<long> : ";  BootList<long>::PrintIDListLen(outFile);}
	if (dataColumnRec::memIDList_.len()>0){outFile<<"dataColumnRec : ";  dataColumnRec::PrintIDListLen(outFile);}
//	if (dataColumnRecNum<int>::memIDList_.len()>0){outFile<<"dataColumnRecNum<int> : ";  dataColumnRecNum<int>::PrintIDListLen(outFile);}
	if (dataColumnRecNum<double>::memIDList_.len()>0){outFile<<"dataColumnRecNum<double> : ";  dataColumnRecNum<double>::PrintIDListLen(outFile);}
//	if (dataColumnRecNum<long>::memIDList_.len()>0){outFile<<"dataColumnRecNum<long> : ";  dataColumnRecNum<long>::PrintIDListLen(outFile);}
	if (dataColumnRecStr::memIDList_.len()>0){outFile<<"dataColumnRecStr : ";  dataColumnRecStr::PrintIDListLen(outFile);}
	if (dataSetRec::memIDList_.len()>0){outFile<<"dataSetRec : ";  dataSetRec::PrintIDListLen(outFile);}
	if (GeneFrequencyDistribution::memIDList_.len()>0){outFile<<"GeneFrequencyDistribution : ";  GeneFrequencyDistribution::PrintIDListLen(outFile);}
	if (GeneticGridCell<float>::memIDList_.len()>0){outFile<<"GeneticGridCell<float> : ";  GeneticGridCell<float>::PrintIDListLen(outFile);}
	if (GeneticLandScape<float>::memIDList_.len()>0){outFile<<"GeneticLandScape<float> : ";  GeneticLandScape<float>::PrintIDListLen(outFile);}
	if (GLM::memIDList_.len()>0){outFile<<"GLM : ";  GLM::PrintIDListLen(outFile);}
	if (GenotypeFreqDistribution::memIDList_.len()>0){outFile<<"GenotypeFreqDistribution : ";  GenotypeFreqDistribution::PrintIDListLen(outFile);}
	if (LandScape::memIDList_.len()>0){outFile<<"LandScape : ";  LandScape::PrintIDListLen(outFile);}
	if (aMatrix<double>::memIDList_.len()>0){outFile<<"aMatrix<double> : ";  aMatrix<double>::PrintIDListLen(outFile);}
	if (matrixHandle<double>::memIDList_.len()>0){outFile<<"matrixHandle<double> : ";  matrixHandle<double>::PrintIDListLen(outFile);}
	if (MatrixList::memIDList_.len()>0){outFile<<"MatrixList : ";  MatrixList::PrintIDListLen(outFile);}
	if (PartitionedMatrix::memIDList_.len()>0){outFile<<"PartitionedMatrix : ";  PartitionedMatrix::PrintIDListLen(outFile);}
	if (Ran3List::memIDList_.len()>0){outFile<<"Ran3List : ";  Ran3List::PrintIDListLen(outFile);}
	if (Ran3::memIDList_.len()>0){outFile<<"Ran3 : ";  Ran3::PrintIDListLen(outFile);}
	if (PopulationGeneticData::memIDList_.len()>0){outFile<<"PopulationGeneticData : ";  PopulationGeneticData::PrintIDListLen(outFile);}
	if (SexualGeneticLandScape<float>::memIDList_.len()>0){outFile<<"SexualGeneticLandScape<float> : ";  SexualGeneticLandScape<float>::PrintIDListLen(outFile);}
	if (SexualGeneticPopulation<float>::memIDList_.len()>0){outFile<<"SexualGeneticPopulation<float> : ";  SexualGeneticPopulation<float>::PrintIDListLen(outFile);}
	if (SexualGeneticIndividual<float>::memIDList_.len()>0){outFile<<"SexualGeneticIndividual<float> : ";  SexualGeneticIndividual<float>::PrintIDListLen(outFile);}
	if (aString::memIDList_.len()>0){outFile<<"aString : ";  aString::PrintIDListLen(outFile);}
	if (StringList::memIDList_.len()>0){outFile<<"StringList : ";  StringList::PrintIDListLen(outFile);}
	if (StatList<int>::memIDList_.len()>0){outFile<<"StatList<int> : ";  StatList<int>::PrintIDListLen(outFile);}
	if (StatList<float>::memIDList_.len()>0){outFile<<"StatList<float> : ";  StatList<float>::PrintIDListLen(outFile);}
	if (StatList<double>::memIDList_.len()>0){outFile<<"StatList<double> : ";  StatList<double>::PrintIDListLen(outFile);}
	if (StatList<long>::memIDList_.len()>0){outFile<<"StatList<long> : ";  StatList<long>::PrintIDListLen(outFile);}
	if (aVector<int>::memIDList_.len()>0){outFile<<"aVector<int> : ";  aVector<int>::PrintIDListLen(outFile);}
	if (aVector<double>::memIDList_.len()>0){outFile<<"aVector<double> : ";  aVector<double>::PrintIDListLen(outFile);}
	if (aVector<long>::memIDList_.len()>0){outFile<<"aVector<long> : ";  aVector<long>::PrintIDListLen(outFile);}
	if (Allele<float>::memIDList_.len()>0){outFile<<"Allele<float> : ";  Allele<float>::PrintIDListLen(outFile);}
	if (RegulatedAllele<float>::memIDList_.len()>0){outFile<<"RegulatedAllele<float> : ";  RegulatedAllele<float>::PrintIDListLen(outFile);}
	if (Phenotype::memIDList_.len()>0){outFile<<"Phenotype : "; Phenotype::PrintIDListLen(outFile);}
	if (Chromosome<float>::memIDList_.len()>0){outFile<<"Chromosome<float> : ";  Chromosome<float>::PrintIDListLen(outFile);}
	if (ChromosomeList<float>::memIDList_.len()>0){outFile<<"ChromosomeList<float> : ";  ChromosomeList<float>::PrintIDListLen(outFile);}
	if (Genome<float>::memIDList_.len()>0){outFile<<"Genome<float> : ";  Genome<float>::PrintIDListLen(outFile);}
	if (RegulatedGenome<float>::memIDList_.len()>0){outFile<<"RegulatedGenome<float> : ";  RegulatedGenome<float>::PrintIDListLen(outFile);}

}//end PrintMemUsageSummary
#endif






#endif
