//ClinePopList.h


#ifndef ClinePopListh
#define ClinePopListh = 1

#include <aList.h>

class ClinePopList;
class DiseqParamRec;
class Shape2ParamRec;
class Shape3ParamRec;
class Shape4ParamRec;
class Shape5ParamRec;
class Shape6ParamRec;
class Shape7ParamRec;
class Shape8ParamRec;
class Shape9ParamRec;

class ClinePopList: public aList<double> {		
		public:	//holds a list and can find a subset from cline shape parameters
				ClinePopList(void){}
				ClinePopList(ClinePopList& a): aList<double>(a){}
				ClinePopList(ClinePopList* a): aList<double>(a){}
		virtual	~ClinePopList(void){}
//		virtual int 	FindCenterPopulations(ParamRec& params, ClinePopList& popList);//false if len()==0
		virtual int 	FindCenterPopulations(Shape2ParamRec& params, ClinePopList& popList);//false if len()==0
		virtual int 	FindCenterPopulations(Shape3ParamRec& params, ClinePopList& popList);
//		virtual int 	FindCenterPopulations(Shape4ParamRec& params, ClinePopList& popList){
//						return FindCenterPopulations((Shape2ParamRec) params, popList);}
		virtual int 	FindCenterPopulations(Shape5ParamRec& params, ClinePopList& popList);
		virtual int 	FindCenterPopulations(Shape6ParamRec& params, ClinePopList& popList);//false if len()==0
		virtual int 	FindCenterPopulations(Shape7ParamRec& params, ClinePopList& popList);
//		virtual int 	FindCenterPopulations(Shape8ParamRec& params, ClinePopList& popList){
//						return FindCenterPopulations((Shape6ParamRec) params, popList);}
//		virtual int 	FindCenterPopulations(Shape9ParamRec& params, ClinePopList& popList){
//						return FindCenterPopulations((Shape7ParamRec) params, popList);}
		virtual void 	Print(ostream& outFile);//outFile assumed open

	friend int operator== (ClinePopList& a, ClinePopList& b){
		return( ((aList<double>)a)==((aList<double>) b));
		}//end operator ==

	friend int operator!= (ClinePopList& a, ClinePopList& b){
		return (!(a==b));}


		};//end class ClinePopList

#endif
