/*******************************************************
*
*	DioeciousGeneticPopulation.cpp															
*
*	Superclass:  SexualGeneticPopulation																							
*
*	This class handles processes within sexually reproducing genetic populations					
********************************************************/

#ifndef DioeciousGeneticPopulationcp
#define DioeciousGeneticPopulationcp = 1


#include "DioeciousGeneticPopulation.h"
#include "Element.cpp"
#include "aList.cpp"
#include "RandomList.cpp"


template <class T> void DioeciousGeneticPopulation<T>::Reproduce (long& idCount, Ran3List& ran){
	//each hermaphrodite reproduces
	//according to its individual fecundity
	//derived classes handle separate genders, genetics, etc.
	//ALL OFFSPRING HAVE NEWLY CHOSEN FATHERS
	long old=babies();
	SexualGeneticPopulation<T>::Reproduce (idCount,ran);//asexuals reproduce too
	for (int i=0;i<females();++i){
		female(i).Reproduce(idCount,ran);}
	if (old != babies()){//frequencies may change
		allFreqCurrent_=sampleSizeCurrent_=0;
		allelesCurrent_=hetExpDataCurrent_=hetObsDataCurrent_=0;}
	} //end DioeciousGeneticPopulation<T>::Reproduce 



#endif


