/**************************************************** 
* 	PopulationIntf.cpp
* 
*	interface for the Population and Individual classes, 
* 	the body of the LandScape program. 
* 
*	
*****************************************************/

#ifndef PopulationIntfcpp
#define PopulationIntfcpp = 1

#include "PopulationIntf.h"
#include "CoordinateClass.cpp"



//int operator== (CoordinateType& a, CoordinateType& b){
//				return ((CoordinateClass<int>)a==(CoordinateClass<int>)b);}

int operator!= (CoordinateType& a, CoordinateType& b){
				return !(a==b);}


int operator== (CoordinateType& a, CoordinateType& b){
			return ((a.data_[0]==b.data_[0])&&(a.data_[1]==b.data_[1])&&(a.data_[2]==b.data_[2]));}
			
			
  	

genderSet genderCode(char genChar){
	switch(genChar){
		case 'A': return A; break;
		case 'a': return A; break;
		case 'B': return B; break;
		case 'b': return B; break;
		case 'H': return B; break;
		case 'h': return B; break;
		case 'F': return F; break;
		case 'f': return F; break;
		case 'M': return M; break;
		case 'm': return M; break;
		default: break;
		}
	aString errStr("Error: EvolutionaryGeneticsData::gender():  \'");
	errStr+genChar; errStr+"\' is not a valid gender code";
	aError(errStr);
	return B;
	}//genderCode(char )
	
	
	
	
genderSet genderCode(aString& genStr){
	if(genStr== "F"){ return F;}
		else if(genStr== "M"){ return M;}
		else if(genStr== "A"){ return A;}
		else if(genStr== "B"){ return B;}
		else if(genStr== "FEMALE" || genStr== "Female" || genStr== "f" || genStr== "female"){ return F;}
		else if(genStr== "MALE" || genStr== "Male" ||genStr== "m" || genStr== "male"){ return M;}
		else if(genStr=="ASEXUAL" || genStr== "Asexual" || genStr== "a" || genStr== "asexual"){ return A;}
		else if(genStr== "BOTH" || genStr== "Both" || genStr== "b" || genStr== "both"){ return B;}
		else if(genStr== "H" || genStr== "HERMAPHRODITE" || genStr== "Hermaphrodite" || genStr== "HERM" || genStr== "Herm"){ return B;}
		else if(genStr== "h" || genStr== "hermaphrodite" || genStr== "herm"){ return B;}
		else{}
	aString errStr("Error: EvolutionaryGeneticsData::gender():  \'");
	errStr+genStr; errStr+"\' is not a valid gender code";
	aError(errStr);
	return B;
	}//genderCode (aString& )




genderSet genderCode(char* rawGenStr){
	aString genStr(rawGenStr);
	return genderCode(genStr);
	}//genderCode(char* )
	
	




#endif
