/***********************************
*
*	SexLinkedDominantMarkerMCMCData.h
*
*	This class links the Metropolis-Hastings MCMC classes with the
*	data structure for codominant markers.
************************************/

#ifndef SexLinkedDominantMarkerMCMCDatah
#define SexLinkedDominantMarkerMCMCDatah = 1

//#include "Element.cpp"
//#include "aList.cpp"
#include "MetropolisHastings.h"
#include "SexLinkedDomMarkerData2.h"
#include "MemoryManager.h"

// class MetropolisHastingsData defined in MetropolisHastings.h

class SexLinkedDominantMarkerMCMCData: virtual public MetropolisHastingsData,
								virtual public SexLinkedDomMarkerData2{
  public:
	
	SexLinkedDominantMarkerMCMCData(void){
//				SetPointerToDerivedSelf();
				}
	SexLinkedDominantMarkerMCMCData(SexLinkedDominantMarkerMCMCData& d){
				SexLinkedDomMarkerData2::Initialize(d);
//				SetPointerToDerivedSelf();
				}
	SexLinkedDominantMarkerMCMCData(SexLinkedDomMarkerData2& cmd){
				SexLinkedDomMarkerData2::Initialize(cmd);
//				SetPointerToDerivedSelf();
				}
		
	~SexLinkedDominantMarkerMCMCData(void){
//				pointerToDerivedSelf_ = 0;
				}
	
//	virtual EvolutionaryGeneticsData* Duplicate(void){
//			return NEW CodominantMarkerMCMCData(*this);}

	virtual SexLinkedDominantMarkerMCMCData* _Duplicate(void){
			return NEW SexLinkedDominantMarkerMCMCData(*this);}

//	virtual void SetPointerToDerivedSelf(void){//always override in derived
//					pointerToDerivedSelf_ = (long)this;}
	virtual long GetPointerToDerivedSelf(void){//always override in derived
					return (long)this;}
						

	
/*	long double q(int pop, int loc, int marker);//local frequency
	
	long double Q(int loc, int marker);//global frequency

	int GloballyPolymorphic(int loc);
	
	int n(int pop, int loc);
	
	long nalleles(int loc);
		
	long nloci(void);
		
	long npop(void);
*/		
		
	};//end class SexLinkedDominantMarkerMCMCData



#endif
