/***************************************************
*																														}
*	SexualIndividual.h																					}
*													
*	This class has to mate before reproducing,
*		but the genetic details are otherwise ignored.
*	All individuals are classed as hermaphrodites by default.
*	Genetic stuff done by derived class SexualGeneticIndividual.
*	Collect data (dispersal etc.) using derived classes.
*
****************************************************/

#ifndef SexualIndividualh
#define SexualIndividualh = 1

//#include <iostream.h>
//#include "RandomList.cpp"
#include "Individual.h"
#include "Element.h"
#include "aList.h"
#include "Randomness.h"
#include "StatList.h"
#include "MemoryManager.h"
//#include "Population.h"


class SexualIndividual: public Individual{
	protected:
		int 				matings_;
		int				matingsThisAgeClass_;// for limits on mating rate
	public:
						SexualIndividual(void);
						SexualIndividual(long id, Population* site=NULL);
						SexualIndividual(SexualIndividual& indiv);
						SexualIndividual(SexualIndividual* indiv);
virtual 	 			~SexualIndividual(void){}
virtual Individual* 		Duplicate(long id,Population* site=NULL);//VIRTUAL COPY CONSTRUCTOR


//THESE OVERRIDE FUNCTIONS IN THE BASE CLASS Individual

virtual void			Birthday (int maxage);
virtual int			CanMate (int maxThisAgeClass);//override for genetic subclasses
virtual void			Clone (Individual* mom);
virtual void			Clone (long& idCount);
//virtual void			Copy (Individual* it);
virtual void			FindMate(Ran3List& ran, int tries, int /* maxThisAgeClass*/);
virtual void			IIndividual (genderSet gender, lifeStageType lifeStage, 
								double rate, Ran3List& ran);
virtual void			IIndividual (genderSet gender, lifeStageType lifeStage, 
								double rate, Ran3List& ran, LandScapeInitializer01& init, aList<double>& extraInfo);
virtual void			MakeABaby (long& idCount, Ran3List& ran);
virtual void			mated(void){++matings_; ++matingsThisAgeClass_;}
virtual int			matings(void){return matings_;}
virtual int			matingsThisAgeClass(void){return matingsThisAgeClass_;}
virtual genderSet 		RealizedSexOfClassMember(double, Ran3&){return B;}
						//returns any one of the possible sexes of this class
virtual void			SetMate (Individual* , int){
							mated();//override for non-selfing subclasses
							}
virtual StringList* 	stateNames(void);//column headings: "matings"
virtual StringList* 	states(void);// indiv values for stateNames() above
	};		//end SexualIndividual

#endif
