//Element.h
#ifndef elementh
#define elementh = 1
//contains the element classes for list classes aList and ObjList,
//which are defined in aList

template<class T> class aList;
template<class T> class ObjList;

template<class T> class NumElem {
	// for int, float, etc. standard objects
	protected:
		T data_;
		NumElem<T> *prev, *next;
	public:
		NumElem(T x);
		T& data(void);
		NumElem<T>* nextElem(void);
		NumElem<T>* prevElem(void);
	friend class aList<T>;
	};//end NumElem


template<class T> class ObjElem {
	// for class and pointer objects
	protected:
		T *data_;
		ObjElem<T> *prev, *next;
	public:
		ObjElem(T* x);
		~ObjElem(void);
		T& data(void);
	friend class ObjList<T>;
	}; //end ObjElem


#endif
