/***********************************************
*
*	LogLikelihoodFunctions.h
*
*	this holds commonly used log-likelihood functions,
*	useful for maximizing likelihoods and comparing them
*
************************************************/


#ifndef LogLikelihoodFunctionsh
#define LogLikelihoodFunctionsh = 1


#include "math.h"
#include "InlineTemplates.h"
#include "Element.h"
#include "aList.h"


long double BinomialLnLikelihood(long n, long r, long double p);

long double NormalLnLikelihood(aList<long double>& x, long double mu, long double sigma);


#endif

