/**********************
*
*	MantelTest.h
*
*	Does a Mantel test to compare two same-sized matrices for 
*	correlations among cells
*
**********************/

#ifndef MantelTesth
#define MantelTesth = 1

#include "Element.h"
#include "aList.h"
#include "aVector.h"
#include "aMatrix.h"
#include "Randomness.h"
#include "BootList.h"
#include "InlineTemplates.h"
#include <math.h>
#include <iostream.h>

long double MantelTestr(aMatrix<long double>& m1, aMatrix<long double>& m2);

long double MantelTest(aMatrix<long double>& m1, aMatrix<long double>& m2,
					long double& r, long double& P, int reps, Ran3& ran);


#endif



