/*********************************************
*
*
*		NormalDistrib
*
*
*		Functions for calculating Normal-distribution statistics
*
*
**********************************************/


#ifndef NormalDistributionh
#define NormalDistributionh = 1

#include <math.h>
#include <iostream.h>
#include "InlineTemplates.h"
#include "Element.h"
#include "aList.h"
#include "MemoryManager.h"


long double NormalDistrib(const long double x, const long double mu, const long double sigma);
		//calculates the height of N(mu,sigma) at point x

long double NormalDistrib(aList<long double>& mu_sigma_x);
		//use for in generalized functions that take lists of variables and parameters
		

#endif

