/***************************************************
																							
	SexualPopulation.h																	
																							
	SuperClass:  Population
	
	Handles sexual reproduction, but genetics done by derived class
	Data analysis handled using derived classes			
																							
***************************************************/

#ifndef SexualPopulationh
#define SexualPopulationh = 1

#include <iostream.h>
#include "Element.h"
#include "aList.h"
#include "Randomness.h"
#include "RandomList.h"
#include "PopulationIntf.h"
#include "Population.h"
#include "Individual.h"
#include "SexualIndividual.h"
#include "MemoryManager.h"


class SexualPopulation: public Population{
	public:
		
		SexualPopulation(long id, int species, GridCell* g, long k):
				Population(id,species,g,k) {}
				
		SexualPopulation(long id): Population(id) {}
		SexualPopulation(SexualPopulation& p): Population(p) {}
		SexualPopulation(SexualPopulation* p): Population(p) {}
virtual ~SexualPopulation(void){}
virtual  Population* Duplicate(long id, int species, GridCell* g, long k){/*virtual constructor*/
				return NEW SexualPopulation(id,species,g,k);}
virtual  Population* Duplicate(long id){/*virtual constructor*/
				return NEW SexualPopulation(id);}

//THESE ARE OVERRIDDEN FROM CLASS Population
virtual void	AssignMates (Ran3List& ran, int tries=1, int maxThisAgeClass=1);
virtual void	Reproduce (long& idCount, Ran3List& ran);

	};	//end SexualPopulation


#endif
