//ClinePopList.cp
#ifndef ClinePopListcp
#define ClinePopListcp = 1

#include<DiseqParamRec.h>
#include<Shape2ParamRec.h>
#include<Shape3ParamRec.h>
#include<Shape4ParamRec.h>
#include<Shape5ParamRec.h>
#include<Shape6ParamRec.h>
#include<Shape7ParamRec.h>
#include<Shape8ParamRec.h>
#include<Shape9ParamRec.h>
#include <ClinePopList.h>


int ClinePopList::FindCenterPopulations(Shape2ParamRec& params, ClinePopList& popList){
	//simply copies the popList
	Clear();//empties the current list
	for (int pop = 0;pop< popList.len();++pop){
		Append(pop);
		}//	end for pop
	if(len()>0){ return 1;} else{return 0;}
	};//end ClinePopList::FindCenterPopulations



int ClinePopList::FindCenterPopulations(Shape3ParamRec& params, ClinePopList& popList){
	//simply copies the popList
	Clear();//empties the current list
	for (int pop = 0;pop< popList.len();++pop){
		Append(pop);
		}//	end for pop
	if(len()>0){ return 1;} else{return 0;}
	};//end ClinePopList::FindCenterPopulations



int ClinePopList::FindCenterPopulations(Shape5ParamRec& params, ClinePopList& popList){
	//simply copies the popList
	Clear();//empties the current list
	for (int pop = 0;pop< popList.len();++pop){
		Append(pop);
		}//	end for pop
	if(len()>0){ return 1;} else{return 0;}
	};//end ClinePopList::FindCenterPopulations



int ClinePopList::FindCenterPopulations(Shape6ParamRec& params, ClinePopList& popList){
	Clear();//empties the current list
	for (int pop = 0;pop< popList.len();++pop){
		double theLocation = popList[pop];
		if ((theLocation >= params.xL()) && (theLocation <= params.xR())) {
			Append(pop);}
		}//	end for pop
	if(len()>0){ return 1;} else{return 0;}
	};//end ClinePopList::FindCenterPopulations



int ClinePopList::FindCenterPopulations(Shape7ParamRec& params, ClinePopList& popList){
	Clear();//empties the current list
	for (int pop = 0;pop< popList.len();++pop){
		double theLocation = popList[pop];
		if ((theLocation >= params.xL()) && (theLocation <= params.xR())) {
			Append(pop);}
		}//	end for pop
	if(len()>0){ return 1;} else{return 0;}
	};//end ClinePopList::FindCenterPopulations



void ClinePopList::Print(ostream& outFile){//outFile assumed open
	outFile<<"Pops included in center region:";
	for(int i=0;i<len();++i){ 
		outFile<<Nth(i)<<"   ";}
	outFile<<endl;
	}//end ClinePopList::Print




/*

int ClinePopList::FindCenterPopulations(ParamRec& params, ClinePopList& popList){
	Clear();//empties the current list
	for (int pop = 0;pop< popList.len();++pop){
		double theLocation = popList[pop];
		if ((theLocation >= params.xL) && (theLocation <= params.xR)) {
			Append(pop);}
		}//	end for pop
	if(len()>0){ return 1;} else{return 0;}
	};//end ClinePopList::FindCenterPopulations




*/

#endif

