//FitMultilocusCline.h


#ifndef FitMultilocusClineh
#define FitMultilocusCline = 1

#include <aList.h>
//#include <Boolean.h>
#include <math.h>
#include <Hyperbolics.h>
#include <InlineTemplates.h>
#include <Randomness.h>
//#include <ParamRec.h>
#include <ClinePopList.h>
//#include "AllozymeClineGlobals.h"

class ParamSetList;
class MultipleSavedParamList;


class CurrentLikelihood{
	public:
		double L;
		ClinePopList centerPops;
	public:
		CurrentLikelihood(void): L(0.0){}
		CurrentLikelihood(ClinePopList& c, double like):
							 L(like), centerPops(c){}
		CurrentLikelihood(ClinePopList* c, double like):
							 L(like), centerPops(c){}
		CurrentLikelihood(CurrentLikelihood& c):
							L(c.L), centerPops(c.centerPops){}
		CurrentLikelihood(CurrentLikelihood* c): 
							L(c->L), centerPops(c->centerPops){}
		~CurrentLikelihood(void){
				centerPops.Clear();}
			
	//equivalence is determined solely by the set of center populations
	friend int operator== (CurrentLikelihood& a, CurrentLikelihood& b){
					return(a.centerPops==b.centerPops);
				}//end operator ==

	friend int operator!= (CurrentLikelihood& a, CurrentLikelihood& b){
		return (!(a==b));}
		
		};//end class CurrentLikelihood





/*
	class ParamSetList: public ObjList<ParamRec> {
		public:
			ClinePopList popSet;
			ParamRec best;
			long maxLen;
		public:
			ParamSetList(long len):maxLen(len){};
			ParamSetList(ClinePopList& a, long len):popSet(a), maxLen(len) {popSet.Sort();}
			ParamSetList(ClinePopList* a, long len):popSet(a), maxLen(len) {popSet.Sort();}
			ParamSetList(ParamSetList& b): ObjList<ParamRec>(b), popSet(b.popSet), maxLen(b.maxLen) {};
			ParamSetList(ParamSetList* b): ObjList<ParamRec>(b), popSet(b->popSet), maxLen(b->maxLen) {};
			~ParamSetList(void){popSet.Clear();}
			void RescaleLtoLmaxRatios (int typeL);
			int 	 SaveParams (ParamRec* paramsToSave,int typeL);//returns boolean

	friend int operator== (ParamSetList& a, ParamSetList& b){
		return ((a.popSet==b.popSet)&&( ((ObjList<ParamRec>)a)==(( ObjList<ParamRec>) b)));
		}//end operator ==

	friend int operator!= (ParamSetList& a, ParamSetList& b){
		return (!(a==b));}

		};//end class ParamSetList


	class MultipleSavedParamList: public ObjList<ParamSetList> {
		public:
			MultipleSavedParamList(void){};
			MultipleSavedParamList(MultipleSavedParamList& a):ObjList<ParamSetList>(a){};
			MultipleSavedParamList(MultipleSavedParamList* a):ObjList<ParamSetList>(a){};
			~MultipleSavedParamList(void){};

	friend int operator== (MultipleSavedParamList& a, MultipleSavedParamList& b){
		return ( ((ObjList<ParamSetList>)a)==(( ObjList<ParamSetList>) b));
		}//end operator ==

	friend int operator!= (MultipleSavedParamList& a, MultipleSavedParamList& b){
		return (!(a==b));}

		};//end class MultipleSavedParamList
*/

#endif
