/*******************************************************
*
*	DioeciousPopulation.cpp															
*
*	Superclass:  SexualPopulation																							
*
*	This class handles processes within dioecious (but not genetic) populations					
********************************************************/

#ifndef DioeciousPopulationcpp
#define DioeciousPopulationcpp = 1



#include "DioeciousPopulation.h"
#include "Element.cpp"
#include "aList.cpp"
#include "RandomList.cpp"


void DioeciousPopulation::Reproduce (long& idCount, Ran3List& ran){
	//INDIVIDUALS MUST MATE LOCALLY TO REPRODUCE
	//first let any asexuals and hermaphrodites reproduce, in case populations are mixed 
	SexualPopulation::Reproduce (idCount,ran);
	for (int i=0;i<females();++i){
		female(i).Reproduce(idCount,ran);}
	} //end SexualPopulation::Reproduce 




#endif
